Bug 34378 - st/mesa: 2a904fd6a0cb80eec6dec2bae07fd8778b04caf3 breaks sauerbraten
st/mesa: 2a904fd6a0cb80eec6dec2bae07fd8778b04caf3 breaks sauerbraten
Status: RESOLVED FIXED
Product: Mesa
Classification: Unclassified
Component: Mesa core
git
x86 (IA32) Linux (All)
: low minor
Assigned To: Marek Olšák
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2011-02-17 02:11 UTC by Fabio Pedretti
Modified: 2011-03-08 14:46 UTC (History)
1 user (show)

See Also:


Attachments
workaround (1.29 KB, patch)
2011-02-17 07:28 UTC, Marek Olšák
Details | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Fabio Pedretti 2011-02-17 02:11:18 UTC
Since 2a904fd6a0cb80eec6dec2bae07fd8778b04caf3 sauerbraten shows triangles popping around on some frames. My card:

r300: DRM version: 2.7.0, Name: ATI RV530, ID: 0x71c5, GB: 1, Z: 2
r300: GART size: 509 MB, VRAM size: 256 MB
r300: AA compression: NO, Z compression: NO, HiZ: NO
Comment 1 Brian Paul 2011-02-17 06:31:54 UTC
That commit is also causing problems with Google Earth running in a VM when using the Gallium svga driver.  If this can't be fixed soon, we may have to revert this patch (and the follow-ons).

Assigning to Marek.  Marek, do you have any ideas about what might be going on?
Comment 2 Marek Olšák 2011-02-17 07:28:16 UTC
Created attachment 43487 [details] [review]
workaround

I guess we might be changing vertex attribs somewhere and not updating
the appropriate dirty flags, therefore we can't rely on them for now.
Or maybe we need to make the vertex array state dependent on some other flags too. I have no idea currently.

I have an ugly workaround which fixes sauerbraten. Please see the attached patch. It basically reverts my commit and gives a clue on what's going on.
Comment 3 Marek Olšák 2011-02-18 00:24:07 UTC
Update: This bug only shows up if shaders are used. The fixed-function pipeline is unaffected.
Comment 4 Alexandros Frantzis 2011-02-18 02:55:18 UTC
Commit 2a904fd6a0cb80eec6dec2bae07fd8778b04caf3 also breaks the cairo-gl backend.

FWIW, the attached workaround fixes the problem.
Comment 5 Fabio Pedretti 2011-03-02 01:10:58 UTC
Note that the workaround was applied in:
http://cgit.freedesktop.org/mesa/mesa/commit/?id=bb46eeade3a3eb604aba5c084d1e21942c2fa2ac
Comment 6 Marek Olšák 2011-03-08 14:46:53 UTC
Fixed with commits ef58598c1cf2ac689f67c75b2f477f2c404fce98 and 12fa91b6753dccbd3aa12c570d1f1e55c7dc0582. Closing.